PROGRAM sudo
  IMPLICIT NONE

  INTEGER, DIMENSION(:,:), ALLOCATABLE:: sudoku
  INTEGER:: n, dimen, i,j,k
  LOGICAL:: line, column, array

  WRITE(*,*) 'Please enter sudoku dimension:'
  READ(*,*) n
  dimen = n ** n
  ALLOCATE(sudoku(dimen,dimen))

  WRITE(*,*) 'Please enter sudoku to test:'
  DO i = 1, dimen
    READ(*,*) sudoku(i,:)
  END DO

  DO i = 1, dimen
    line = ALL(ANY(sudoku==i, 1))
    WRITE(*,*) 'Number ', i, ' is in every line: ', line
  END DO

  DO i = 1, dimen
    column = ALL(ANY(sudoku==i, 2))
    WRITE(*,*) 'Number ', i, ' is in every column: ', column
  END DO

  DO k = 1, dimen
    array = .TRUE.
    DO i = 1, n
      DO j = 1 , n
        array = array .AND. ANY(sudoku((i-1)*n+1:i*n,(j-1)*n+1:j*n)==k)
      END DO
    END DO
    WRITE(*,*) 'Number ', k, ' is in every array: ', array
  END DO

END PROGRAM sudo
