PROGRAM tanz
  IMPLICIT NONE

  INTEGER:: ios, anzahl, i,j,temp,k
  INTEGER,DIMENSION(:),ALLOCATABLE::per
  INTEGER,DIMENSION(:),ALLOCATABLE::pkt

  TYPE teilnehmer
    INTEGER:: nummer
    CHARACTER(LEN=30):: name
  END TYPE

  TYPE(teilnehmer), DIMENSION(:), ALLOCATABLE:: male, female
    !1. Einlesen und sortieren
  OPEN(UNIT=33, IOSTAT=ios, FILE="tanzpaare.txt", STATUS="OLD", ACTION="READ")

  IF(ios==0) THEN
    READ(33,*,IOSTAT=ios) anzahl
    IF(ios == 0) THEN
      ALLOCATE(male(anzahl), female(anzahl))

      DO i = 1, anzahl
        READ(UNIT=33,FMT=*) male(i)%nummer, female(i)%name, male(i)%name
        female(i)%nummer = male(i)%nummer
      END DO

      ALLOCATE(pkt(anzahl),per(anzahl))
      pkt = 0
      DO i = 1,anzahl
        per(i) = i
      END DO
      WRITE(*,*) 'Please enter result:'
        DO i = 1, anzahl
          READ(*,*) pkt(i)
          DO j = 1,i-1
            IF(pkt(i) >= pkt(per(j)))THEN
              temp = per(i)
              DO k = i-1,j,-1
                per(k+1) = per(k)
              END DO
              per(j) = temp
              EXIT
            END IF
          END DO
        END DO

        !2. Ausgabe
      OPEN(UNIT=35, IOSTAT=ios, FILE='tanzresult.dat',STATUS='REPLACE', ACTION='WRITE')

      IF(ios == 0) THEN
        WRITE(35,FMT='(4X,A,10X,A,10X,A)')"1. Platz","2. Platz","3. Platz"
        WRITE(UNIT=35,FMT='(*(A18,X))',ADVANCE='NO') female(per(:))%name
        WRITE(35,*)
        WRITE(UNIT=35,FMT='(*(A18,X))',ADVANCE='NO') male(per(:))%name
        WRITE(35,*)
        WRITE(UNIT=35,FMT='(*(7X,I2,9X))', ADVANCE='NO') pkt(per(:))
        WRITE(35,*)
        CLOSE(35)
      ELSE
        WRITE(*,*) 'ERROR: Cannot open new file.'
      END IF
      DEALLOCATE(male,female,pkt,per)
    ELSE
      WRITE(*,*) 'ERROR: Cannot read file.'
    END IF
    CLOSE(33)
  ELSE
    WRITE(*,*) 'ERROR: Cannot open tanzpaare.txt!'
  END IF

END PROGRAM tanz
