PROGRAM tanz
  IMPLICIT NONE

  INTEGER:: ios33,ios35, anzahl, iosread, i, res

  TYPE teilnehmer
    INTEGER:: nummer
    CHARACTER(LEN=30):: name
  END TYPE

  TYPE(teilnehmer), DIMENSION(:), ALLOCATABLE:: male, female

  OPEN(UNIT=33, IOSTAT=ios33, FILE="tanzpaare.txt", STATUS="OLD", ACTION="READ")

  IF(ios33==0) THEN
    READ(33,*,IOSTAT=iosread) anzahl
    IF(iosread == 0) THEN
      ALLOCATE(male(anzahl), female(anzahl))
      DO i = 1, anzahl
        READ(UNIT=33,FMT=*) male(i)%nummer, female(i)%name, male(i)%name
        female(i)%nummer = male(i)%nummer
      END DO

      OPEN(UNIT=35, IOSTAT=ios35, FILE='tanzresult.dat',STATUS='REPLACE', ACTION='WRITE')

      IF(ios35 == 0) THEN
        WRITE(UNIT=35,FMT='(*(A18,X))',ADVANCE='NO') female(:)%name
        WRITE(35,*)
        WRITE(UNIT=35,FMT='(*(A18,X))',ADVANCE='NO') male(:)%name
        WRITE(35,*)
        WRITE(*,*) 'Please enter result:'
        DO i = 1, anzahl
          READ(*,*) res
          WRITE(UNIT=35,FMT='(7X,I2,9X)', ADVANCE='NO') res

        END DO
      ELSE
        WRITE(*,*) 'ERROR: Cannot open new file.'
      END IF
    ELSE
      WRITE(*,*) 'ERROR: Cannot read file.'
    END IF
  ELSE
    WRITE(*,*) 'ERROR: Cannot open tanzpaare.txt!'
  END IF

END PROGRAM tanz
