program recursion

    implicit none
    integer     :: count_rec, count_iter, count_iter2, count, i, j, gcd, k

    count_iter = 0
    count_rec = 0
    count_iter2 = 0

    do k = 1, 4
        do i = 1, 10**k
            do j = 1, 10**k
                count = 0
                gcd = gcd_iterative(i, j, count)
                if(count > count_iter) count_iter = count

                count = 0
                gcd = gcd_iterative2(i, j, count)
                if(count > count_iter2) count_iter2 = count

                count = 0
                gcd = gcd_recursive(i, j, count)
                if(count > count_rec) count_rec = count

                
            end do
        end do 
        write(*,*)"Anzahl iterativ:", count_iter, count_iter2, "Anzahl recursiv:", count_rec
    end do

    contains

        recursive function gcd_recursive(a, b, count) result(res)
            integer, intent(in)     :: a, b
            integer                 :: res
            integer, intent(inout)  :: count
            count = count + 1
            if( b == 0) then 
                res = a
            else
                res = gcd_recursive(b, mod(a,b), count)
            end if
        end function gcd_recursive





        function gcd_iterative(a, b, count)
            integer, intent(in)     :: a, b
            integer                 :: gcd_iterative
            integer, intent(inout)  :: count

            do gcd_iterative=min(a,b), 1, -1
                count = count + 1
                if(mod(a, gcd_iterative) == 0 .and. mod(b, gcd_iterative) == 0) then
                    exit
                end if
            end do
        end function gcd_iterative







        function gcd_iterative2(i, j, count)
            integer, intent(in)     :: i,j
            integer                 :: gcd_iterative2, swap,a,b
            integer, intent(inout)  :: count
            a = i
            b = j
            if(a == 0) then
                gcd_iterative2 = b
            else
                do while(b /= 0)
                    count = count + 1
                    swap = mod(a,b)
                    a = b 
                    b = swap
                end do
                gcd_iterative2 = a
            end if

        end function gcd_iterative2

end program recursion
